/* --COPYRIGHT--,BSD
 * Copyright (c) 2012, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
//Author: Kripa Venkat
// MSP430 Applications Team
// Last modified Aug 2009
// Pure decryption code

#include<stdio.h>
#include<math.h>
extern unsigned char F[32],A[64], B[56], C0[28],D0[28],L0[32],R0[32],L1[32],R1[32],M[64],MM[64],X[48],Y[48],B11[2],B111[4],Final[64],Final1[64];
extern unsigned char L2[32],R2[32],L3[32],R3[32],L4[32],R4[32],L5[32],R5[32],L6[32],R6[32],L7[32],R7[32],L8[32],R8[32],
              L9[32],R9[32],L10[32],R10[32],L11[32],R11[32],L12[32],R12[32],L13[32],R13[32],L14[32],R14[32],
              L15[32],R15[32],L16[32],R16[32],Lf[32],Rf[32]; 
extern unsigned char B1[6],B2[6],B3[6],B4[6],B5[6],B6[6],B7[6],B8[6];
extern unsigned char C1[28],D1[28],C2[28],D2[28],C3[28],D3[28],C4[28],D4[28];
extern unsigned char C5[28],D5[28],C6[28],D6[28],C7[28],D7[28],C8[28],D8[28];
extern unsigned char C9[28],D9[28],C10[28],D10[28],C11[28],D11[28],C12[28],D12[28];
extern unsigned char C13[28],D13[28],C14[28],D14[28],C15[28],D15[28],C16[28],D16[28];
extern unsigned char CD[17][56];
extern unsigned char PC1[];

extern unsigned char PC2[];
extern unsigned char IP[];
extern unsigned char E[];
extern unsigned char S1[][16];
extern unsigned char S2[][16];
extern unsigned char S3[][16];
extern unsigned char S4[][16];
extern unsigned char S5[][16];
extern unsigned char S6[][16];
extern unsigned char S7[][16];
extern unsigned char S8[][16];
extern unsigned char P[];
extern unsigned char IP1[];
extern void Ff(unsigned char *B,unsigned char *S,int incr);//wat to give for 2d array index???
extern unsigned long int sum;          
extern unsigned char K[17][48],*ptr;

extern unsigned long int K1,K2,M1,M2,temp,U,V;
extern int i,j,B12,B122,Z,Z1[4],rem,ZF[32],incr,count,func_count;



static void LR(unsigned char *,unsigned char *, int);
static unsigned char Decr_msg[16];


void decrypt(unsigned long * Key, unsigned long *Message, unsigned long *Result)
{
/*
	K1=0x13345779;
	K2=0x9BBCDFF1;
        M1=0x85e81354;
        M2=0x0f0ab405;
*/
    K1 = Key[0];
    K2 = Key[1];
    M1 = Message[0];
    M2 = Message[1];
	for(i=0;i<32;i++)
	{
	  temp=K1&0x80000000;
          if (temp==0)
	    A[i]=0;
          else
            A[i]=1;
          temp=K2&0x80000000;
	  if (temp==0)
	    A[i+32]=0;
          else
            A[i+32]=1;  
            K1= K1<<1;        // Bit Extraction
            K2= K2<<1;
        }
        
	// Permuted key array B 56-bits from A 64-bits
        
        for(i=0;i<56;i++)
	{
	    B[i]=A[PC1[i]-1];
	}
	for(i=0;i<28;i++)
        {
            C0[i]=B[i];         // CO and DO array
            D0[i]=B[i+28];
        }
        // C1 and D1 array        
        for (i=0;i<27;i++)
        {
            C1[i]=C0[i+1];
            D1[i]=D0[i+1];
        }
        C1[27]=C0[0];
        D1[27]=D0[0];
        
	// C2 and D2 array
	for (i=0;i<27;i++)
        {
	    C2[i]=C1[i+1];
	    D2[i]=D1[i+1];
        }
	C2[27]=C1[0];
        D2[27]=D1[0];
        
        // C3 and D3 array        
        for (i=0;i<26;i++)
        {
            C3[i]=C2[i+2];
            D3[i]=D2[i+2];
        }
	C3[26]=C2[0];
	D3[26]=D2[0];
        C3[27]=C2[1];
        D3[27]=D2[1];
        
	// C4 and D4 array
        for (i=0;i<26;i++)
        {
	    C4[i]=C3[i+2];
	    D4[i]=D3[i+2];
        }
	C4[26]=C3[0];
        D4[26]=D3[0];
        C4[27]=C3[1];
        D4[27]=D3[1];

	// C5 and D5 array
        for (i=0;i<26;i++)
        {
            C5[i]=C4[i+2];
            D5[i]=D4[i+2];
        }
        C5[26]=C4[0];
        D5[26]=D4[0];
        C5[27]=C4[1];
	D5[27]=D4[1];

        // C6 and D6 array        
	for (i=0;i<26;i++)
	{
	    C6[i]=C5[i+2];
	    D6[i]=D5[i+2];
        }
        C6[26]=C5[0];
        D6[26]=D5[0];
        C6[27]=C5[1];
        D6[27]=D5[1];
        
        // C7 and D7 array        
        for (i=0;i<26;i++)
        {
            C7[i]=C6[i+2];
            D7[i]=D6[i+2];
        }
        C7[26]=C6[0];
	D7[26]=D6[0];
	C7[27]=C6[1];
        D7[27]=D6[1];

	// C8 and D8 array
       for (i=0;i<26;i++)
	{
            C8[i]=C7[i+2];
            D8[i]=D7[i+2];
        }
        C8[26]=C7[0];
        D8[26]=D7[0];
        C8[27]=C7[1];
        D8[27]=D7[1];
        
	// C9 and D9 array
	for (i=0;i<27;i++)
        {
            C9[i]=C8[i+1];
            D9[i]=D8[i+1];
	}
        C9[27]=C8[0];
        D9[27]=D8[0];

	// C10 and D10 array
        for (i=0;i<26;i++)
	{
            C10[i]=C9[i+2];
            D10[i]=D9[i+2];
        }
	C10[26]=C9[0];
	D10[26]=D9[0];
        C10[27]=C9[1];
        D10[27]=D9[1];

        // C11 and D11 array        
        for (i=0;i<26;i++)
        {
            C11[i]=C10[i+2];
            D11[i]=D10[i+2];
	}
        C11[26]=C10[0];
        D11[26]=D10[0];
	C11[27]=C10[1];
	D11[27]=D10[1];


        // C12 and D12 array        
        for (i=0;i<26;i++)
        {
            C12[i]=C11[i+2];
            D12[i]=D11[i+2];
        }
        C12[26]=C11[0];
        D12[26]=D11[0];
        C12[27]=C11[1];
        D12[27]=D11[1];

        
        // C13 and D13 array        
	for (i=0;i<26;i++)
	{
            C13[i]=C12[i+2];
	    D13[i]=D12[i+2];
	}
        C13[26]=C12[0];
	D13[26]=D12[0];
        C13[27]=C12[1];
        D13[27]=D12[1];

        
        // C14 and D14 array        
        for (i=0;i<26;i++)
        {
            C14[i]=C13[i+2];
	    D14[i]=D13[i+2];
	}
        C14[26]=C13[0];
        D14[26]=D13[0];
        C14[27]=C13[1];
	D14[27]=D13[1];

        // C15 and D15 array          
	for (i=0;i<26;i++)
	{
            C15[i]=C14[i+2];
	    D15[i]=D14[i+2];
        }
        C15[26]=C14[0];
        D15[26]=D14[0];
	C15[27]=C14[1];
	D15[27]=D14[1];

        
        // C16 and D16 array        
        for (i=0;i<27;i++)
        {
            C16[i]=C15[i+1];
            D16[i]=D15[i+1];
        }
	C16[27]=C15[0];
        D16[27]=D15[0];
   
	// Subkeys K1 to K16 using PC2

	for (j=0;j<28;j++)
	{
            CD[1][j]=C1[j];
            CD[1][j+28]=D1[j];
            CD[2][j]=C2[j];
            CD[2][j+28]=D2[j];
            CD[3][j]=C3[j];
            CD[3][j+28]=D3[j];
            CD[4][j]=C4[j];
            CD[4][j+28]=D4[j];
            CD[5][j]=C5[j];
            CD[5][j+28]=D5[j];
            CD[6][j]=C6[j];
            CD[6][j+28]=D6[j];
            CD[7][j]=C7[j];
	    CD[7][j+28]=D7[j];
	    CD[8][j]=C8[j];
            CD[8][j+28]=D8[j];
	    CD[9][j]=C9[j];
	    CD[9][j+28]=D9[j];
            CD[10][j]=C10[j];
	    CD[10][j+28]=D10[j];
            CD[11][j]=C11[j];
            CD[11][j+28]=D11[j];
            CD[12][j]=C12[j];
            CD[12][j+28]=D12[j];
            CD[13][j]=C13[j];
            CD[13][j+28]=D13[j];
            CD[14][j]=C14[j];
            CD[14][j+28]=D14[j];
	    CD[15][j]=C15[j];
	    CD[15][j+28]=D15[j];
            CD[16][j]=C16[j];
            CD[16][j+28]=D16[j];   // For convenience CD array does not have the first row
            // of elements hence goes from 1 to 16, instead of 0 to 15. 
	}
        for(i=1;i<17;i++)
        {
	    for (j=0;j<48;j++)
	    {
                K[i][j]=CD[i][PC2[j]-1];
	    }
        }
//step2:encode data
        for(i=0;i<32;i++)
	{
	  temp=M1&0x80000000;
          if (temp==0)
            M[i]=0;
          else
            M[i]=1;
          temp=M2&0x80000000;
          if (temp==0)
            M[i+32]=0;
          else
	    M[i+32]=1;
         
            M1= M1<<1;        // Bit Extraction
	    M2= M2<<1;
	}
	for(i=0;i<64;i++)
		MM[i]=M[IP[i]-1];
        for(i=0;i<32;i++)
        {
            R0[i]=MM[i];         // LO and RO array
            L0[i]=MM[i+32];
        }
 
        for(count=15;count>=0;count--)
            LR(L0,R0,count);
        for(i=0;i<32;i++)
	{
	    Final[i]=L0[i];
	    Final[i+32]=R0[i];
	}
        for(i=0;i<64;i++)
        {
           Final1[i]=Final[IP1[i]-1];
          //Final1[i]=Final[i];
        }
        sum=0;
        for(i=0,j=0;i<64;i+=4,j++)
        {
            Decr_msg[j]=Final1[i]*8+Final1[i+1]*4+Final1[i+2]*2+Final1[i+3];
        }

        Result[0] = 0;
        Result[1] = 0;
        
        for (i=0; i < 8; i ++)
        {
            Result[0] += ((unsigned long)Decr_msg[i]<<(28-(4*i)));
        }
        for (i=0; i < 8; i ++)
        {
            Result[1] += ((unsigned long)Decr_msg[i+8]<<(28-(4*i)));
        }

/*
        for(i=0;i<16;i++)
          printf("%x",Decr_msg[i]);
*/
}//end main


void LR(unsigned char *Lf,unsigned char *Rf,int func_count)
{
	 unsigned char L[32],R[32]; //Lf has L0 and Rf has R0 addresses
	 for(i=0;i<32;i++)
           R[i]=*(Lf+i);            // No problem here
	 for(i=0;i<48;i++)
	 {
           X[i]=*(Lf+(E[i]-1));
	 }
	 for(j=0;j<48;j++)
	 {
	     if(K[func_count+1][j]==X[j])        //XOR-inbuilt func
	     Y[j]=0;
	     else
	     Y[j]=1;              // XOR of E(Ln) and Kn is complete
	 }
	 for(i=0;i<6;i++)
	 {
	     B1[i]=Y[i];
	     B2[i]=Y[i+6];
	     B3[i]=Y[i+12];
	     B4[i]=Y[i+18];
	     B5[i]=Y[i+24];
	     B6[i]=Y[i+30];
             B7[i]=Y[i+36];
             B8[i]=Y[i+42];
          }
        
	 incr=0;
	 ptr=&S1[0][0];
	 Ff(B1,ptr,incr);
	 incr=4;
	 ptr=&S2[0][0];;
	 Ff(B2,ptr,incr);
	 incr=8;
	 ptr=&S3[0][0];;
	 Ff(B3,ptr,incr);
	 incr=12;
	 ptr=&S4[0][0];;
	 Ff(B4,ptr,incr);
	 incr=16;
	 ptr=&S5[0][0];;
	 Ff(B5,ptr,incr);
	 incr=20;
	 ptr=&S6[0][0];;
	 Ff(B6,ptr,incr);
	 incr=24;
	 ptr=&S7[0][0];;
	 Ff(B7,ptr,incr);
	 incr=28;
	 ptr=&S8[0][0];;
	 Ff(B8,ptr,incr);
	   for(i=0;i<32;i++)
	   F[i]=ZF[P[i]-1];
	    for(j=0;j<32;j++)
	    {
	     if(F[j]==*(Rf+j))        //XOR
	     *(L+j)=0;
	     else
	     *(L+j)=1;
	   }
	   for(i=0;i<32;i++)
	   {
		*(Lf+i)=L[i];
		*(Rf+i)=R[i];
	   }

}
