/* --COPYRIGHT--,BSD
 * Copyright (c) 2012, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
//Author: Kripa Venkat
// MSP430 Applications Team
// Last modified Aug 2009
// Pure decryption code

#include<stdio.h>
#include<math.h>
unsigned char F[32],A[64], B[56], C0[28],D0[28],L0[32],R0[32],L1[32],R1[32],M[64],MM[64],X[48],Y[48],B11[2],B111[4],Final[64],Final1[64];
unsigned char L2[32],R2[32],L3[32],R3[32],L4[32],R4[32],L5[32],R5[32],L6[32],R6[32],L7[32],R7[32],L8[32],R8[32],
              L9[32],R9[32],L10[32],R10[32],L11[32],R11[32],L12[32],R12[32],L13[32],R13[32],L14[32],R14[32],
              L15[32],R15[32],L16[32],R16[32],Lf[32],Rf[32]; 
unsigned char B1[6],B2[6],B3[6],B4[6],B5[6],B6[6],B7[6],B8[6];
unsigned char C1[28],D1[28],C2[28],D2[28],C3[28],D3[28],C4[28],D4[28];
unsigned char C5[28],D5[28],C6[28],D6[28],C7[28],D7[28],C8[28],D8[28];
unsigned char C9[28],D9[28],C10[28],D10[28],C11[28],D11[28],C12[28],D12[28];
unsigned char C13[28],D13[28],C14[28],D14[28],C15[28],D15[28],C16[28],D16[28];
unsigned char CD[17][56];
unsigned char PC1[]={0x39,0x31,0x29,0x21,0x19,0x11,0x09,0x01,0x3a,0x32,0x2a,0x22,
            0x1a,0x12,0x0a,0x02,0x3b,0x33,0x2b,0x23,0x1b,0x13,0x0b,0x03,0x3c,0x34,
            0x2c,0x24,0x3f,0x37,0x2f,0x27,0x1f,0x17,0x0f,0x07,0x3e,0x36,0x2e,0x26,
	    0x1e,0x16,0x0e,0x06,0x3d,0x35,0x2d,0x25,0x1d,0x15,0x0d,0x05,0x1c,0x14,
            0x0c,0x04};
unsigned char PC2[]={14,17,11,24,1,5,3,28,15,6,21,10,23,19,12,4,26,8,16,7,27,20,
	    13,2,41,52,31,37,47,55,30,40,51,45,33,48,44,49,39,56,34,53,46,42,50,
            36,29,32};
unsigned char IP[]={58,50,42,34,26,18,10,2,60,52,44,36,28,20,12,4,62,54,46,38,30,22,
                     14,6,64,56,48,40,32,24,16,8,57,49,41,33,25,17,9,1,59,51,43,35,27,19,
                      11,3,61,53,45,37,29,21,13,5,63,55,47,39,31,23,15,7};   
unsigned char E[]={32,1,2,3,4,5,4,5,6,7,8,9,8,9,10,11,12,13,12,13,14,15,16,17,16,17,18,
                    19,20,21,20,21,22,23,24,25,24,25,26,27,28,29,28,29,30,31,32,1};    
unsigned char S1[][16]={{14,4,13,1,2,15,11,8,3,10,6,12,5,9,0,7},
                      {0,15,7,4,14,2,13,1,10,6,12,11,9,5,3,8},
		      {4,1,14,8,13,6,2,11,15,12,9,7,3,10,5,0},
                      {15,12,8,2,4,9,1,7,5,11,3,14,10,0,6,13}}; 
unsigned char S2[][16]={{15,1,8,14,6,11,3,4,9,7,2,13,12,0,5,10},
                       {3,13,4,7,15,2,8,14,12,0,1,10,6,9,11,5},
                       {0,14,7,11,10,4,13,1,5,8,12,6,9,3,2,15},
                       {13,8,10,1,3,15,4,2,11,6,7,12,0,5,14,9}};
unsigned char S3[][16]={{10,0,9,14,6,3,15,5,1,13,12,7,11,4,2,8},
                      {13,7,0,9,3,4,6,10,2,8,5,14,12,11,15,1},
		      {13,6,4,9,8,15,3,0,11,1,2,12,5,10,14,7},
                      {1,10,13,0,6,9,8,7,4,15,14,3,11,5,2,12}};
unsigned char S4[][16]={{7,13,14,3,0,6,9,10,1,2,8,5,11,12,4,15},
                      {13,8,11,5,6,15,0,3,4,7,2,12,1,10,14,9},
                      {10,6,9,0,12,11,7,13,15,1,3,14,5,2,8,4},
		      {3,15,0,6,10,1,13,8,9,4,5,11,12,7,2,14}};
unsigned char S5[][16]={{2,12,4,1,7,10,11,6,8,5,3,15,13,0,14,9},
                      {14,11,2,12,4,7,13,1,5,0,15,10,3,9,8,6},
                      {4,2,1,11,10,13,7,8,15,9,12,5,6,3,0,14},
                      {11,8,12,7,1,14,2,13,6,15,0,9,10,4,5,3,}};
unsigned char S6[][16]={{12,1,10,15,9,2,6,8,0,13,3,4,14,7,5,11},
                      {10,15,4,2,7,12,9,5,6,1,13,14,0,11,3,8},
		      {9,14,15,5,2,8,12,3,7,0,4,10,1,13,11,6},
                      {4,3,2,12,9,5,15,10,11,14,1,7,6,0,8,13}};
unsigned char S7[][16]={{4,11,2,14,15,0,8,13,3,12,9,7,5,10,6,1},
		      {13,0,11,7,4,9,1,10,14,3,5,12,2,15,8,6},
                      {1,4,11,13,12,3,7,14,10,15,6,8,0,5,9,2},
                      {6,11,13,8,1,4,10,7,9,5,0,15,14,2,3,12}};
unsigned char S8[][16]={{13,2,8,4,6,15,11,1,10,9,3,14,5,0,12,7},
                      {1,15,13,8,10,3,7,4,12,5,6,11,0,14,9,2},
                      {7,11,4,1,9,12,14,2,0,6,10,13,15,3,5,8},
                      {2,1,14,7,4,10,8,13,15,12,9,0,3,5,6,11}};
unsigned char P[]={16,7,20,21,29,12,28,17,1,15,23,26,5,18,31,10,
                    2,8,24,14,32,27,3,9,19,13,30,6,22,11,4,25};
unsigned char IP1[]={ 40,8,48,16,56,24,64,32,39,7,47,15,55,23,63,31,38,6,46,14,
		      54,22,62,30,37,5,45,13,53,21,61,29,36,4,44,12,52,20,60,28,
                      35,3,43,11,51,19,59,27,34,2,42,10,50,18,58,26,33,1,41,9,49,17,57,25};

void Ff(unsigned char *B,unsigned char *S,int incr);//wat to give for 2d array index???
unsigned long int sum=0;          
unsigned char K[17][48],*ptr;

unsigned long int K1,K2,M1,M2,temp,U,V;
int i,j,B12=0,B122=0,Z,Z1[4]={0,0,0,0},rem=0,ZF[32],incr,count,func_count;

void Ff(unsigned char *B,unsigned char *S,int incr)
	 {
		    U=*(B+5)+*(B+0)*2;                     //index for the row
		    V=*(B+1)*8+*(B+2)*4+*(B+3)*2+*(B+4);      //index for column
		    Z=*(S+(U*16)+V);
		     for(i=incr;i<incr+4;i++)
		     {
			     temp=Z&0x08;
			     if (temp==0)
				 ZF[i]=0;
			     else
				 ZF[i]=1;
			     Z= Z<<1;        // Bit Extraction
		      }


	  }
